package com.example.office.controller;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.mindrot.jbcrypt.BCrypt;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;



@RestController
public class LoanController {
	@Autowired
    HttpSession session;
	@RequestMapping(value = "/login",method=RequestMethod.POST)
	public ResponseEntity<?> validate(@RequestParam String uid,@RequestParam String pass)
	{
		HttpHeaders headers = new HttpHeaders(); 
		
		  String cookie="xyz";
		  String hashedCookie=hashPassword(cookie);
		  int age=60*60*24*7;
		  headers.add("Set-Cookie",hashedCookie+"; Max-Age="+age);
		 
		session.setAttribute("token",cookie);
		
		if(uid.equals("admin") && pass.equals("1234"))
		{
			ResponseEntity<?> res=  ResponseEntity.status(HttpStatus.OK).headers(headers).body("Welcome "+uid);
			return res;
		}
		else
		{
			ResponseEntity<?> res=  ResponseEntity.status(HttpStatus.NOT_FOUND).body("Invalid credentials");
			return res;
		}
	}
	
	@RequestMapping("allAccount")
	public List<?> getAllAccounts(HttpServletRequest request)
	{
		String rawCookie = request.getHeader("Cookie");
		String hashedToken=rawCookie.substring(0,rawCookie.indexOf(";"));
		
		String token=(String)session.getAttribute("token");
		
		
		if(checkPass(token,hashedToken))
		{
			List<Account> allAccount=new ArrayList<Account>();
		    for(int i=0;i<5;i++)
		    {
			Account acc=new Account();
			acc.setAccountNo(i+1000);
			acc.setAmount((i+100)*200000);
			allAccount.add(acc);
		     }
		return allAccount;
		}
		else
		{
			List<AccountError> error=new ArrayList<AccountError>();
			AccountError ae=new AccountError();
			ae.setMessage("Authorization failed");
			error.add(ae);
			return error;
		}
		
	}
	
	private String hashPassword(String plainTextPassword){
	    return BCrypt.hashpw(plainTextPassword, BCrypt.gensalt());
	}
	private boolean checkPass(String plainPassword, String hashedPassword) {
		if (BCrypt.checkpw(plainPassword, hashedPassword))
		{
			
			return true;
		}
		else
		{
		
		  return false;
		}
	}
}
